#!/usr/bin/env perl

$num_perfile=1;
$num_files=82944;
$num_folders=1;
$copasi_path="/home/mlux/Desktop/copasi/bin/CopasiSE";
$path = "/home/mlux/Desktop/";
$subfolder = "models82944";

$non_bistable = 0;
$check = 0;
$bistable_count=0;

#Create index of all files
$a=1;$c1=1;$e1=1;$c2=1;$e2=4;$g=1;$h=1;$f=1;$d=1;$b=1;
$init=0;
for $i (1 .. $num_files) {
    @index[$i]="plasmid_a$a"."c$c1"."e$e1"."c$c2"."e$e2"."g$g"."h$h"."f$f"."d$d"."b$b";
    if ($init == 0) {
        $init = 1;
    } elsif ($b < 3) {
        $b++;
        $init=0;
    } elsif ($d < 8) {
        $d++;
        $init=0;$b=1;
    } elsif ($f < 3) {
        $f++;
        $init=0;$d=1;$b=1;
    } elsif ($c2 < 8) {
        $c2++;
        $init=0;$d=1;$b=1;$f=1;
    } elsif ($e1 < 3) {
        $e1++;
        $init=0;$d=1;$b=1;$f=1;$c2=1;
    } elsif ($c1 < 8) {
        $c1++;
        $init=0;$d=1;$b=1;$f=1;$c2=1;$e1=1;
    } elsif ($a < 3) {
        $a++;
        $init=0;$d=1;$b=1;$f=1;$c2=1;$e1=1;$c1=1;
    }   
}

#Loop to go through each file
#(i.e. each set of initial conditions)
for $file_num (1 .. $num_files) {
    if ($file_num % 2 == 0) {
        $init_num = 2;
    } else {
        $init_num = 1;
    }
    $subpath=$subfolder;
    if ($init_num == 1) {
        $filename="@index[$file_num]"."high";
    }
    if ($init_num == 2) {
        $filename="@index[$file_num]"."low";
    }

    $xml_in = "$subpath/$filename.xml";
    $cps_out = "$subpath/$filename.cps";
    $text_out = "$subpath/$filename.txt";

    #Convert SBML to cps
    system("$copasi_path", "-i", "$path$xml_in", "-s", "$path$cps_out");

    #Search txt file for GFP SS info and store it
    #Open file
    open (cps_in, "<$cps_out") or die "Can't Open $cps_out:$!\n\n";
    @store_cps=<cps_in>;
    close cps_in;
    #open output file
    open (cpsSS_out, ">$cps_out") or die "Can't Open $cps_out:$!\n\n";
    #Seach file
    for (@store_cps) {
        s/(.*?)steadyState" scheduled="false/$1steadyState" scheduled="true/;
        s/(.*?)target=""(.*?)append="1"/$1target="$path$text_out"$2append="0"/;
        s/(.*?)Jacobian(.*?)value="1"/$1Jacobian$2value="0"/;
        s/(.*?)StabilityAnalysis(.*?)value="1"/$1StabilityAnalysis$2value="0"/;
        s/(.*?)Resolution(.*?)value="1e-09"/$1Resolution$2value="1e-01"/;
        s/(.*?)Use Newton(.*?)value="1"/$1Use Newton$2value="0"/;
        s/(.*?)Use Back(.*?)value="1"/$1Use Back$2value="0"/;
        s/Relative Tolerance(.*?)"1e-06"/Relative Tolerance$1"1e-12"/;
        s/quantityUnit="mmol"/quantityUnit="#"/;
        s/3.011070750000001e\+\d\d/5000/;
        s/6.022141500000001e\+\d\d/1/;
        s/6.022141500000001e\+\d\d/1/;
        s/6.022141500000001e\+\d\d/1/;
        s/6.022141500000001e\+\d\d/1/;
        s/Max Internal(.*?)value="10000"/Max Internal$1value="10000000"/;
        print cpsSS_out;
    }
    close cpsSS_out;

    #Execute SS analysis
    system("$copasi_path", "$path$cps_out");

    #Search txt file for GFP SS info and store it
    #Open file
    open (file, "$text_out") or die "Can't Open $text_out:$!\n\n";
    #Seach file
    for $line(<file>) {
        #Search for GFP and extract the relevant nearby info
        if($line =~ m/(\w+)_protein_gfpmut3(\s+)(.*?)(\s+)/) {
            $GFP=$3;
            #Store GFP Value and plasmid name in the correct array
            if($init_num==1) {
                $ref = ($file_num + 1) / 2;
                @GFP_1[$ref] = $GFP;
                @plas_name[$ref] = $1;
                @plas_folder[$ref] = $folder;
            }
            if($init_num==2) {
                $ref = $file_num / 2;
                @GFP_2[$ref] = $GFP;
                #Calculate Bistability Info
                @bistable_diff[$ref] = abs(@GFP_2[$ref] - @GFP_1[$ref]) / @GFP_2[$ref] * 100;
                @bistable_absdiff[$ref]=abs(@GFP_2[$ref] - @GFP_1[$ref]);
                @bistable_ratio[$ref]=@GFP_1[$ref]/@GFP_2[$ref];
                #Check to see if values are within 1% of eachother
                if( @bistable_diff[$ref] > 1 ) {
                    @bistable_constructs[$ref]=@plas_name[$ref];
                    @is_bistable[$ref]=YES;
                    $bistable_count++;
                }
                else {
                    $non_bistable++;
                    @is_bistable[$ref]=NO;
                }                         
            }
        }
    }
    close file;
}

#Parse model names into parts
for $k (0 .. $ref) {
    @plas_name[$k] =~ m/a(\d)c(\d)e(\d)c(\d)e4g1h1f(\d)d(\d)b(\d)/;
    if ($1 == 1) {
        $prom1 = "ptrc-2";
    } elsif ($1 == 2) {
        $prom1 = "pls1con";
    } elsif ($1 == 3) {
        $prom1 = "pltet01";
    }
    if ($2 == 1) {
        $rbs1 = "A";
    } elsif ($2 == 2) {
        $rbs1 = "B";
    } elsif ($2 == 3) {
        $rbs1 = "C";
    } elsif ($2 == 4) {
        $rbs1 = "D";
    } elsif ($2 == 5) {
        $rbs1 = "E";
    } elsif ($2 == 6) {
        $rbs1 = "F";
    } elsif ($2 == 7) {
        $rbs1 = "G";
    } elsif ($2 == 8) {
        $rbs1 = "H";
    }
    if ($3 == 1) {
        $gene1 = "lacI";
    } elsif ($3 == 2) {
        $gene1 = "cIts";
    } elsif ($3 == 3) {
        $gene1 = "tetR";
    }
    if ($4 == 1) {
        $rbs2 = "A";
    } elsif ($4 == 2) {
        $rbs2 = "B";
    } elsif ($4 == 3) {
        $rbs2 = "C";
    } elsif ($4 == 4) {
        $rbs2 = "D";
    } elsif ($4 == 5) {
        $rbs2 = "E";
    } elsif ($4 == 6) {
        $rbs2 = "F";
    } elsif ($4 == 7) {
        $rbs2 = "G";
    } elsif ($4 == 8) {
        $rbs2 = "H";
    }
    if ($5 == 1) {
        $gene2 = "lacI_r";
    } elsif ($5 == 2) {
        $gene2 = "cIts_r";
    } elsif ($5 == 3) {
        $gene2 = "tetR_r";
    }
    if ($6 == 1) {
        $rbs3 = "A_r";
    } elsif ($6 == 2) {
        $rbs3 = "B_r";
    } elsif ($6 == 3) {
        $rbs3 = "C_r";
    } elsif ($6 == 4) {
        $rbs3 = "D_r";
    } elsif ($6 == 5) {
        $rbs3 = "E_r";
    } elsif ($6 == 6) {
        $rbs3 = "F_r";
    } elsif ($6 == 7) {
        $rbs3 = "G_r";
    } elsif ($6 == 8) {
        $rbs3 = "H_r";
    }
    if ($7 == 1) {
        $prom2 = "ptrc-2_r";
    } elsif ($7 == 2) {
        $prom2 = "pls1con_r";
    } elsif ($7 == 3) {
        $prom2 = "pltet01_r";
    }
    @plas_parts[$k] = "$prom1 $rbs1 $gene1 $rbs2 GFPmut3 $gene2 $rbs3 $prom2";
}
       



#Output results to a file
$results_path = "$path"."82944_results.txt";
#$results_path = "$path" . "$subfolder/results.txt";
open (results, ">$results_path") or die "Can't Open $results_path:$!\n\n";
print results "Plas_name Prom1 Rbs1 Gene1 Rbs2 Reporter Gene_r1 Rbs_r1 Prom_r1 SS1 SS2 Bistable? \%Difference Abs_Diff Ratio\n";
for $j (0 .. $ref) {
    print results "@plas_name[$j] @plas_parts[$j] @GFP_1[$j] @GFP_2[$j]  @bistable_diff[$j] @bistable_absdiff[$j] @bistable_ratio[$j] @is_bistable[$j]\n";
}
print results "\nBistable $bistable_count\n";
print results "NonBistable $non_bistable\n";
close results;

print "\nTime - $^T\n\n";\n\n";